/** forkexercise -- demonstrate the use of multiprogramming API
 *
 * CS 162 Fall 2011 - Project 1, individual assignment
 *
 * fork(2)
 * exec(3)
 * wait(2)
 *
 * @author Jorge Ortiz <jortiz@eecs.berkeley.edu>
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char **argv) {
  FILE *fp;
  int tid;
  int waitint;

  fp = fopen("test.txt", "a");
  if (!fp) {
    perror("fopen");
    return 1;
  }

  printf("[%i] parent starting up\n", getpid());
  tid = fork();
  if(tid > 0) {
    printf("[%i] parent about to wait\n", getpid());
    fprintf(fp, "[%i] parent wrote to file\n", getpid());
    fclose(fp);

    wait(&waitint);
    printf("[%i] wait returned: wait_int: %d\n", getpid(), waitint);
  } else {
    char *exec_argv[3] = {"external", "hello from exec!", NULL};

    printf("[%i] child running\n", getpid());
    fprintf(fp, "[%i] child wrote to file\n", getpid());
    fclose(fp);

    execv("external", exec_argv);
  }
  return 0;
}
